/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.CSVSeparator;
import fr.istic.mML.DataInput;
import fr.istic.mML.MMLPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Input</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.DataInputImpl#getFile <em>File</em>}</li>
 *   <li>{@link fr.istic.mML.impl.DataInputImpl#getCsvSeparator <em>Csv Separator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DataInputImpl extends MinimalEObjectImpl.Container implements DataInput
{
  /**
   * The default value of the '{@link #getFile() <em>File</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFile()
   * @generated
   * @ordered
   */
  protected static final String FILE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getFile() <em>File</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFile()
   * @generated
   * @ordered
   */
  protected String file = FILE_EDEFAULT;

  /**
   * The cached value of the '{@link #getCsvSeparator() <em>Csv Separator</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCsvSeparator()
   * @generated
   * @ordered
   */
  protected CSVSeparator csvSeparator;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DataInputImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.DATA_INPUT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getFile()
  {
    return file;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setFile(String newFile)
  {
    String oldFile = file;
    file = newFile;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.DATA_INPUT__FILE, oldFile, file));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public CSVSeparator getCsvSeparator()
  {
    return csvSeparator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCsvSeparator(CSVSeparator newCsvSeparator, NotificationChain msgs)
  {
    CSVSeparator oldCsvSeparator = csvSeparator;
    csvSeparator = newCsvSeparator;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.DATA_INPUT__CSV_SEPARATOR, oldCsvSeparator, newCsvSeparator);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCsvSeparator(CSVSeparator newCsvSeparator)
  {
    if (newCsvSeparator != csvSeparator)
    {
      NotificationChain msgs = null;
      if (csvSeparator != null)
        msgs = ((InternalEObject)csvSeparator).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.DATA_INPUT__CSV_SEPARATOR, null, msgs);
      if (newCsvSeparator != null)
        msgs = ((InternalEObject)newCsvSeparator).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.DATA_INPUT__CSV_SEPARATOR, null, msgs);
      msgs = basicSetCsvSeparator(newCsvSeparator, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.DATA_INPUT__CSV_SEPARATOR, newCsvSeparator, newCsvSeparator));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MMLPackage.DATA_INPUT__CSV_SEPARATOR:
        return basicSetCsvSeparator(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.DATA_INPUT__FILE:
        return getFile();
      case MMLPackage.DATA_INPUT__CSV_SEPARATOR:
        return getCsvSeparator();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.DATA_INPUT__FILE:
        setFile((String)newValue);
        return;
      case MMLPackage.DATA_INPUT__CSV_SEPARATOR:
        setCsvSeparator((CSVSeparator)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.DATA_INPUT__FILE:
        setFile(FILE_EDEFAULT);
        return;
      case MMLPackage.DATA_INPUT__CSV_SEPARATOR:
        setCsvSeparator((CSVSeparator)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.DATA_INPUT__FILE:
        return FILE_EDEFAULT == null ? file != null : !FILE_EDEFAULT.equals(file);
      case MMLPackage.DATA_INPUT__CSV_SEPARATOR:
        return csvSeparator != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (file: ");
    result.append(file);
    result.append(')');
    return result.toString();
  }

} //DataInputImpl
